<?php
/*
Plugin Name: 2D_video complete intuitive embed solution.
Plugin URI: http://www.2diabolos.com/blog/plugins-pour-wordpress/2d_video-plugin
Description: Converts Video-Links in your posts to embedded Video-Players.<br />Supports: local mp4,flv... and platforms Youtube, Dailymotion, MyVideo Google Video and many more ...
Author: Thierry B
Author URI: http://www.2diabolos.com/blog
Version: 0.6

a big amount of code come from "bbVideo" bbPress plugin from Naden Badalgogtapeh
the lookups function comes from Subs-Aeva.php v6, another plugin written by Rene-Gilles Deberdt (created by Karl Benson)
*/

/*** class video_2D_obj  */

class video_2D_obj {
  /**
   * list of supported video providers
   */
  var $provider;

  /**
   * plugin id for filter hooks
   */
  var $wp_filter_id;

  var $index;
  var $options;
  var $baseUrl;
  var $admin_modified;
 /**
   * public constructor
   */
  function video_2D_obj() {
	global $video_provider;

    $this->wp_filter_id = '2D_video';
	$this->baseUrl = plugins_url('',__FILE__);

	add_action('admin_menu', array(&$this, 'video_2D_config_page'));
	add_action('save_post',array(&$this, 'after_save_post'),10,2);

	$this->options = get_option( '2D_video' );
	if ($this->options === false)
		return false;

	$this->admin_modified = get_option( '2D_video_modified' );

    $this->provider = array();

	add_action('wp_head',array( &$this, 'AddHeader' ));


    //if( isset($video_provider) )  {
	add_filter( 'the_content', 'make_clickable', 90 );
	add_filter( 'the_content', array( &$this, 'ContentFilter' ), 99 );
    //}
  }

  function video_2D_config_page() {
	if ( function_exists('add_submenu_page') )
		add_submenu_page('plugins.php', __('2D_video'), __('2D_video'), 'manage_options', '2D_video/admin.php');

  }

  function AddHeader()  {
	echo '<script type="text/javascript">var url_2D_video = "'.$this->baseUrl.'";</script>
		<script type="text/javascript" src="'.$this->baseUrl.'/2D_video.js"></script>
		<style type="text/css" media="screen">.play_b{position:absolute;left:45%;top:45%}</style>'."\n";
  }

  function image_delay_url() {
	if (substr($this->options['image_delay'],0,4) == "http")
		return $this->options['image_delay'];
	else return $this->baseUrl.'/images/'.$this->options['image_delay'];
  }

  function play_button_url() {
	if (substr($this->options['play_button'],0,4) == "http")
		return $this->options['play_button'];
	else return $this->baseUrl.'/images/'.$this->options['play_button'];
  }

  function add_post_meta_replace ($post_ID,$replace_params) {

	$replace_params['needle'] = array($replace_params['needle']);
	$replace_params['replace'] = array($replace_params['replace']);
	$old_value = get_post_meta($post_ID, $this->wp_filter_id, true);
	if ($old_value != '')  {
	  $replace_params = array_merge_recursive($old_value , $replace_params);
	  update_post_meta($post_ID, $this->wp_filter_id, $replace_params);
	} else {
	  add_post_meta($post_ID, $this->wp_filter_id, $replace_params);
	}
	update_post_meta($post_ID, $this->wp_filter_id . "_modified", time());
  }

  function after_save_post($post_ID,$post) {
	delete_post_meta($post->ID, $this->wp_filter_id.'_modified');
  }

  function ContentFilter( $buffer ){
	global $post;
	//if (false) {
	if ($this->admin_modified < get_post_meta($post->ID, $this->wp_filter_id.'_modified', true) ) {
		$post_meta_replace = get_post_meta($post->ID, $this->wp_filter_id, true);
		return str_replace($post_meta_replace['needle'],$post_meta_replace['replace'],$buffer);
	} else {
		delete_post_meta($post->ID, $this->wp_filter_id);

		if ( empty( $this->provider ) ) {
			include( dirname( __FILE__ ) . '/provider.inc.php' );
			$this->provider  = $video_provider;
		}

		/// detect all links in the current topic
		@preg_match_all( '`<a([^>]*)href=["\'](http(s?)\://(.*))["\'](.*)>(.*)</a>`iU', $buffer, $links , PREG_SET_ORDER );
		//echo "un lien <br>\n"; 	echo show_r($links); 	echo "<br>\n";
		$count = count( $links[0] );

		foreach( $links as $link ){
		  foreach( $this->provider as $k => $provider ) {
			@preg_match( '`' . $provider[ 'pattern' ] . '`i', $link[2], $matches );
			if( count( $matches ) > 0 ){
				$this->index +=1;
				if ($provider['type']=="local" && $this->options['play_delayed']==0)
					$provider['code'] =$provider['embed'];
				if (!empty($provider['lookup-pattern'])) {
					$actual = $this->lookup_lookup_and_match($provider['lookup-pattern'] , $link[2]);
					// echo "in ContentFIlter, provider['lookup-pattern'] , link[2] = " . $provider['lookup-pattern'] . "," . $link[2]. "<br>";
					// echo "resultat = ".show_r($actual)."<br>";
					@preg_match( '`' . $provider[ 'lookup-pattern' ] . '`i', $actual['inline'], $matches );
					// echo "matches = ".show_r($matches)."<br>";
				}

				$code = str_replace(
					array( '[ID]', '[HEIGHT]', '[WIDTH]'), #,'[HASH]','[IMAGE_DELAY]','[PLAY_BUTTON]'
					array( $matches[ $provider[ 'index' ] ], $provider[ 'height' ], $provider[ 'width' ]),
					#, substr(md5($matches[ $provider[ 'index' ] ]),0,10) ,$this->image_delay_url()
					$provider['code']);

				$url = '<a href="http://www.2diabolos.com/blog/plugins-pour-wordpress/2d_video-plugin" style="color:#aaa;text-decoration:underline;">video plugin</a>';
				if( $this->options[ 'download' ] == 1 ){
					$download = '<a style="color: #000;" href="'.
						(  ($provider['type']=="local") ? $link[2] : "http://www.degrab.de/?url=".urlencode($link[2])  ).
						'" target="_blank">Video Download</a>';
				}
				if( $this->options[ 'embed' ] == 1 ){
					$post_title = str_replace( "'", '', $post->post_title );
					$post_link = get_permalink();

					if( isset( $download ) ){
					  $download = ' | ' . $download;
					}

					if ($provider['type']=="local" && $this->options['play_delayed']=="1")
						$embed= array('label'=>"File link","code"=>$link[2]);
					else
						$embed= array('label'=>"Embed","code"=>$code);

					$code = <<<DATA
					<div style="width:{$provider['width']}px;text-indent:0;display:table">{$code}<div>
					<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr><td><a href="#video2D{$this->index}" id="video2D{$this->index}" onClick="o=document.getElementById('video2D{$this->index}embed'); if (o.style.display=='block') {o.style.display='none';this.innerHTML = this.innerHTML.replace( /-/, '+' );} else {o.style.display='block';this.innerHTML = this.innerHTML.replace( /\+/, '-' );};return(false);" style="color: #000;">[+] Embed the video</a>{$download}</td><td align="right" style="color:#aaa;font-size:80%;">Get the {$url}</td></tr></table>

					<div id="video2D{$this->index}embed" style="display:none;">
					<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr><td width="80">Text-Link:</td><td><input type="text" value="{$post_link}" onclick="javascript:this.focus();this.select();" style="width:100%;" /></td></tr>
					<tr><td width="80">HTML-Link:</td><td><input type="text" value='<a href="{$post_link}">{$post_title}</a>' onclick="javascript:this.focus();this.select();" style="width:100%;" /></td></tr>
					<tr><td width="80">BB-Code:</td><td><input type="text" value="[url={$post_link}]{$post_title}[/url]" onclick="javascript:this.focus();this.select();" style="width:100%;" /></td></tr>
					<tr><td width="80">{$embed['label']}:</td><td><input type="text" value='{$embed['code']}' onclick="javascript:this.focus();this.select();" style="width:100%;" /></td></tr>
					</table>
					</div></div></div>
DATA;
				} else {
					if( isset( $download ) ){
					  $download = '<td>' . $download . '</td>';
					}
				}
				$replace_params = array('needle'=>$link[0],
					'replace'=>$code . (($link[2]==$link[6])? "": "<br>" . $link[6] )
					);

				$this->add_post_meta_replace($post->ID,$replace_params);
				$buffer = str_replace( $replace_params['needle'],
					$replace_params['replace'],
					$buffer);
				unset( $code );
				break;
			}
		  }
		}
		reset( $this->provider );
		update_post_meta($post->ID, $this->wp_filter_id . "_modified", time());
		return( $buffer );
	}
  }


  // add AEVA lookup support
	function lookup_lookup_youtube($url, $fmt) {
		$data = @lookup_fetch($url . $fmt);
		if (empty($data) || strlen($data) < 100)
			return false;
		preg_match('~"fmt_map": "(?:(\d+)(?:/\d+){4}[,"])~im', $data, $yt);
		return isset($yt[1]) && $yt[1] == $fmt;
	}

	// The 'Lookup' Function to grab and match a regex
	function lookup_lookup_and_match($regex, $url, $fetch_title = ''){

		// Don't timeout.
		@set_time_limit(600);

		// We might need more ummmmph.
		@ini_set('memory_limit', '60M');

		// Go get 'em tiger
		$data = $this->lookup_fetch($url,true);
		// Return if empty or too short to be a proper response/page
		if (empty($data) || strlen($data) < 100)
			return false;

		$ret = array();
		if (is_array($fetch_title))
			foreach ($fetch_title as $search_title)
			{
				if (!preg_match('~' . $search_title . '~is', $data, $output) || empty($output[1]) || trim($output[1]) == '')
					continue;
				$ret['title'] = preg_replace('~\s+~', ' ', trim(strip_tags($output[1])));
				break;
			}

		// Find the actual data inside the page. Returns false on failure.
		if (!is_array($regex))
			return array('inline' => !empty($regex) && preg_match('~' . $regex . '~im', $data, $output) ? $output[1] : false,
						'title' => !empty($ret['title']) ? $ret['title'] : '');

		foreach ($regex as $a => $b){
			if (!is_array($b) && preg_match('~' . $b . '~i', $data, $output))
				$ret[$a] = isset($output[1]) ? $output[1] : '';
			// YouTube quality lookup? We have some work ahead of us...
			elseif (is_array($b) && preg_match('~' . $b[0] . '~i', $data, $output)
			&& !empty($output[0]) && preg_match_all('~' . $b[1] . '~i', $output[0], $output) !== false)
			{
				$cnt = 2;
				$qualities = array();
				while (isset($b[$cnt]))
				{
					if (in_array($b[$cnt], $output[1]))
						$qualities[] = $b[$cnt+1];
					else
						// Some formats are cool but not always published by YT. We have to test them remotely.
						if (in_array($b[$cnt], array(18, 35)) && lookup_lookup_youtube($url . '&fmt=', $b[$cnt]))
							$qualities[] = $b[$cnt+1];
					$cnt += 2;
				}
				if (count($qualities) == 0)
					$ret['normal'] = '';
				else
					while ($q = array_pop($qualities))
						$ret[$q] = '';
			}
		}
		return $ret;
	}

	function lookup_utf8_decode($s){
		if (!ereg("[\200-\237]", $s) && !ereg("[\241-\377]", $s))
			return $s;

		$s = preg_replace("~([\340-\357])([\200-\277])([\200-\277])~e", "'&#'.((ord('\\1')-224<<12)+(ord('\\2')-128<<6)+ord('\\3')-128).';'", $s);
		$s = preg_replace("~([\300-\337])([\200-\277])~e", "'&#'.((ord('\\1')-192<<6)+ord('\\2')-128).';'", $s);

		return $s;
	}


	function lookup_lookups_obtain_callback($input){
		global $context, $sites,$post;
		$arr = $sites[$this->upto];
		echo "lookup_lookups_obtain_callback arr vaut". show_r($arr);
		// On callback this is an array
		if (is_array($input)){
			// Secondary url  - we use the variable in another url.
			$url = !empty($arr['lookup-actual-url']) ? str_replace('$1', $input[3], $arr['lookup-actual-url']) : $input[2];
			// Search for a title if: link has no existing title, current video site has a title lookup, or all video sites
			// are set to look for a title, and title storage is enabled (lookup_titles is not 1 or 3). I know, it's a bit scary.

			echo "input dans lookup_lookups_obtain_callback vaut". show_r($input);

			$has_title = preg_match('~(?:<a [^>]+>|\[url=[^]]+])(.+)(?:</a>|\[/url])~', $input[0], $tst);
			$lookup_title = (empty($arr['lookup-title']) &&  isset($arr['lookup-title'])) || !empty($has_title)
							? false : array('<meta\s+name="title"\s+content="([^"]+)"', '<title>([^<]+)</title>');
			if (is_array($lookup_title) && !empty($arr['lookup-title']) && $arr['lookup-title'] !== true)
				array_unshift($lookup_title, $arr['lookup-title']);
			$actual = empty($arr['lookup-pattern']) && empty($lookup_title) ? false : $this->lookup_lookup_and_match(!empty($arr['lookup-pattern']) ? $arr['lookup-pattern'] : '', $url, $lookup_title);
			if (is_array($actual))
			{
				if (isset($actual['title']))
				{
					$title = $actual['title'];
					unset($actual['title']);
					if (isset($actual['inline']))
						$actual = empty($actual['inline']) ? $url : $actual['inline'];
				}
				if (isset($actual['w'], $arr['size'][0]) && $actual['w'] == $arr['size'][0])
					unset($actual['w']);
				if (isset($actual['h'], $arr['size'][1]) && $actual['h'] == $arr['size'][1])
					unset($actual['h']);
				if (is_array($actual) && (empty($arr['lookup-skip-empty']) || !empty($actual)))
				{
					if (!empty($arr['lookup-final-url']))
					{
						$url = $arr['lookup-final-url'];
						$final_id = $actual['id'];
						unset($actual['id']);
					}
					$opt = '#';
					foreach ($actual as $a => $b)
						$opt .= $a . str_replace('-', '~', $b) . '-';
					$actual = $url . substr($opt, 0, max(1, strlen($opt)-1));
				}
			}

			// Failed so return
			if (empty($actual))
				return $input[0];

			// Url-decode some characters
			if (!empty($arr['lookup-urldecode']))
				for ($j = 0; $j < $arr['lookup-urldecode']; $j++)
					$actual = urldecode($actual);

			// Unencode some html characters to prevent double encoding by SMF
			if (!empty($arr['lookup-unencode']))
				$actual = un_htmlspecialchars($actual);

			// If we were only returned a partial url, we add the remainder/actual bit here
			if (!empty($arr['lookup-final-url']))
			{
				$actual = empty($final_id) ? str_replace('$1', $actual, $arr['lookup-final-url']) : str_replace('$1', $final_id, $actual);
				// Cheat to put the original url looked up back in the link
				$actual = str_replace('$2', $url, $actual);
			}
			if (!empty($title))
				$title = html_entity_decode(str_replace('&amp;', '&', $context['utf8'] ? $title : $this->lookup_utf8_decode($title)), ENT_QUOTES);

			$replace_params = array('needle'=>$input[2], 'replace'=>$actual );
			$this->add_post_meta_replace($post->ID,$replace_params);
			return !empty($title) ? '[' . $input[1] . '=' . $actual . ']' . $title . '[/' . $input[1] . ']' : str_replace($replace_params['needle'], $replace_params['replace'], $input[0]);
		}
		else
		{
			// Complete the regex pattern
			$regex = '~(<a href=")(' . (!empty($arr['lookup-url']) ? $arr['lookup-url'] : $arr['pattern']) . ')"[^>]*>[^<]*</a>~i' . ($context['utf8'] ? 'u' : '');
			return preg_replace_callback($regex, array( &$this,'lookup_lookups_obtain_callback'), $input);
		}
	}

	function lookup_lookups_match($input)
	{
		global $context, $sites;
		// Create an array for our vars
		if (empty($context['aeva']))
			$context['aeva'] = array();

		// Count sites
		$j = count($sites);

		// For each enabled site to the end, attempt to embed
		for ($this->upto = 0; $this->upto < $j; $this->upto++)
			if (  !empty($sites[$this->upto]['lookup-url']) || (!empty($sites[$this->upto]['lookup-title']) )  )
				$input = $this->lookup_lookups_obtain_callback($input);

		// Undo All protection
		$input = str_replace('aeva://', 'http://', $input);

		// All sites are done.
		return $input;
	}

	function lookup_curl_redir_exec($ch)
	{
		static $curl_loops = 0;
		if ($curl_loops++ >= 20)
		{
			$curl_loops = 0;
			return false;
		}
		curl_setopt($ch, CURLOPT_HEADER, true);
		$data = curl_exec($ch);
		list($header, $data) = preg_split("/(\n\n|\r\r|\r\n\r\n)/", $data, 2);
		$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		if ($http_code == 301 || $http_code == 302)
		{
			$matches = array();
			preg_match('/Location:(.*?)[\r\n]/', $header, $matches);
			if ($url = @parse_url(trim(array_pop($matches))))
			{
				$last_url = parse_url(curl_getinfo($ch, CURLINFO_EFFECTIVE_URL));
				$url['scheme'] = $url['scheme'] ? $url['scheme'] : $last_url['scheme'];
				$url['host'] = $url['host'] ? $url['host'] : $last_url['host'];
				$url['path'] = $url['path'] ? $url['path'] : $last_url['path'];
				$new_url = $url['scheme'] . '://' . $url['host'] . $url['path'] . ($url['query'] ? '?' . $url['query'] : '');
				curl_setopt($ch, CURLOPT_URL, $new_url);
				return $this->lookup_curl_redir_exec($ch);
			}
		}
		$curl_loops = 0;
		return $data;
	}

	function lookup_file_get_contents($url) {
		if (!function_exists('curl_init') || !$c = curl_init())
			return false;
		curl_setopt($c, CURLOPT_URL, $url);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($c, CURLOPT_TIMEOUT, 3);
		$contents = curl_exec($c);
		if (!$contents)
			$contents = $this->lookup_curl_redir_exec($c);
		curl_close($c);
		return $contents ? $contents : false;
	}

	function lookup_download_to_string($url, &$file)
	{
		$ctx = stream_context_create(array('http' => array('timeout' => 3)));
		$file = @file_get_contents($url, 0, $ctx);
		if (!$file)
			$file = @implode('', @file($url, 0, $ctx));
		if (!$file)
			$file = $this->lookup_file_get_contents($url);
	}

	// Get the contents of a URL, irrespective of allow_url_fopen.
	function lookup_fetch($url, $test_connection = false) {
		preg_match('~^(http)(s)?://([^/:]+)(:(\d))?(.+)$~', $url, $match);

		if (empty($match[1]))
			return false;

		$data = '';
		@ini_set('user_agent', 'Opera/9.21 (PHP/WP/Aeva; U; fr)');
		$this->lookup_download_to_string($url, $data);
		if (!empty($data))
			return $data;

		// Open the socket on the port we want...
		$fp = @fsockopen(($match[2] ? 'ssl://' : '') . $match[3], empty($match[5]) ? ($match[2] ? 443 : 80) : $match[5], $err, $err, 5);
		if (!$fp)
			return false;

		// I want this, from there, and I'm not going to be bothering you for more (probably.)
		fwrite($fp, 'GET ' . $match[6] . ' HTTP/1.0' . "\r\n");
		fwrite($fp, 'Host: ' . $match[3] . (empty($match[5]) ? ($match[2] ? '443' : '') : ':' . $match[5]) . "\r\n");
		fwrite($fp, 'User-Agent: Opera/9.21 (PHP/SMF/Aeva; U; fr)' . "\r\n");
		fwrite($fp, 'Connection: close' . "\r\n\r\n");

		// Make sure we get a response.
		$response = fgets($fp, 768);
		if ((preg_match('~^HTTP/.+\s+[23][0-9][0-9]\s~i', $response, $reply) != 1) || $test_connection)
		{
			fclose($fp);
			return $test_connection ? $reply[0] : false;
		}

		// Skip the headers...
		while (!feof($fp) && trim($header = fgets($fp, 4096)) != '')
			if (preg_match('~content-length:\s*(\d+)~i', $header, $match) != 0)
				$content_length = $match[1];

		if (isset($content_length))
		{
			while (!feof($fp) && strlen($data) < $content_length)
				$data .= fread($fp, $content_length - strlen($data));
		}
		else
			while (!feof($fp))
				$data .= fread($fp, 4096);

		fclose($fp);

		return $data;
	}
} // end class video_2D_obj

/// init plugin
if( !isset( $video_2D_obj ) || is_null( $video_2D_obj ) ) {
  $video_2D_obj = new video_2D_obj();
}
?>